#include "bitarray.h"

BitArray::BitArray(){
    size = 0;
}

BitArray::BitArray(int n){
    setSize(n);
}

BitArray::~BitArray(){
//    delete[] bits;
    //std::cout << size << std::endl;
}

void BitArray::setSize(int n){

    bits = new bool[n];
    size = n;

}

int BitArray::getSize(void){
    return size;
}

void BitArray::init(int opt){
    int i = 0;
    bool v = false;
    if(opt == INIT_ONES) v = true;
    else if(opt == INIT_ZEROS) v = false;
    while(i < size){
        bits[i++] = v;
    }
}

void BitArray::setValue(int pos, bool val){
    this->bits[pos] = val;
}

bool BitArray::getValue(int pos){
    return this->bits[pos];
}

void BitArray::print(){
    int i = 0;
    while(i < size) std::cout << bits[i++];
    std::cout << std::endl;
}

void BitArray::splitTo(BitArray& bit_a, BitArray& bit_b, int s){
    bit_a.setSize(s);
    bit_b.setSize(this->size-s);

    int i;
    for(i=0;i<s;i++){
        bit_a.setValue(i,this->bits[i]);
    }
    for(i=s;i<this->size;i++){
        bit_b.setValue(i-s,this->bits[i]);
    }

}

void BitArray::split(BitArray& bit_a, BitArray& bit_b){
    splitTo(bit_a, bit_b, this->size/2);
}


BitArray BitArray::getBits(int s, int e){
    int i;
    BitArray b_tmp;
    b_tmp.setSize(e-s);
    for(i = s; i < e; i++){
        b_tmp.setValue(i,this->bits[i]);
    }
    return b_tmp;
}

void BitArray::lShift(int s){
    int i;
    s = s % this->size;
    bool *tmp_bits = new bool[this->size];
    for(i = s; i<this->size; i++){
        tmp_bits[i-s] = this->bits[i];
    }
    for(i = 0; i<s; i++){
        tmp_bits[i+this->size-s] = this->bits[i];
    }
    for(i = 0; i<this->size; i++){
        this->bits[i] = tmp_bits[i];
    }
    delete[] tmp_bits;
}

void BitArray::rShift(int s){
    int i;
    s = s % this->size;
    bool *tmp_bits = new bool[this->size];
    for(i = s; i<this->size; i++){
        tmp_bits[i] = this->bits[i-s];
    }
    for(i = 0; i<s; i++){
        tmp_bits[i] = this->bits[i+this->size-s];
    }
    for(i = 0; i<this->size; i++){
        this->bits[i] = tmp_bits[i];
    }
    delete[] tmp_bits;
}

void BitArray::fromString(std::string s)
{
    int i = 0;
    while(i<this->size){
        if(s[i] == '1')
            this->bits[i] = true;
        else this->bits[i] = false;
        i++;
    }
}

std::string BitArray::toString()
{
    std::string s = "";
    for(int i = 0; i<this->size; i++){
        s.append(((this->bits[i]==1)?"1":"0"));
    }
    return s;
}

BitArray& BitArray::operator=(BitArray b){
    int i;
    size = b.getSize();
    for(i=0;i<size;i++){
        bits[i] = b.getValue(i);
    }
    return *this;
}
