#ifndef BITARRAY_H
#define BITARRAY_H

#define INIT_ZEROS 0x124
#define INIT_ONES 0x125

#include <iostream>

class BitArray{
private:
    bool *bits;
    int size;
public:
    BitArray();
    BitArray(int);
    void setSize(int);
    void init(int);
    void setValue(int, bool);
    bool getValue(int);
    int getSize(void);
    BitArray getBits(int, int);
    void print(void);
    void split(BitArray&, BitArray&);
    void splitTo(BitArray&, BitArray&, int);
    void lShift(int);
    void rShift(int);
    void fromString(std::string);
    std::string toString();
    BitArray& operator=(BitArray);
    ~BitArray();
};

#endif // BITARRAY_H
