#include "bitarray.h"
#include "sdes.h"

#define M_ENCRYPT 0x00
#define M_DECRYPT 0x01

BitArray permute10(BitArray b){
    BitArray tmp_b(10);
    int p[] = {2,4,1,6,3,9,0,8,7,5};
    int i;

    for(i = 0; i< tmp_b.getSize(); i++){
        tmp_b.setValue(i,b.getValue(p[i]));
    }

    return tmp_b;
}

BitArray permute8(BitArray b){
    BitArray tmp_b(8);
    int p[] = {5,2,6,3,7,4,9,8};
    int i;

    for(i = 0; i< tmp_b.getSize(); i++){
        tmp_b.setValue(i,b.getValue(p[i]));
    }

    return tmp_b;
}

BitArray permute4(BitArray b1, BitArray b2){
    BitArray tmp_b(4);
    tmp_b.setValue(0,b1.getValue(1));
    tmp_b.setValue(1,b2.getValue(1));
    tmp_b.setValue(2,b2.getValue(0));
    tmp_b.setValue(3,b1.getValue(0));

    return tmp_b;
}

BitArray exp_permute(BitArray b){
    BitArray tmp_b(8);
    int p[] = {3,0,1,2,1,2,3,0};
    int i;

    for(i = 0; i< tmp_b.getSize(); i++){
        tmp_b.setValue(i,b.getValue(p[i]));
    }

    return tmp_b;
}

BitArray ip(BitArray b){
    BitArray tmp_b(8);
    int p[] = {1,5,2,0,3,7,4,6};
    int i;

    for(i = 0; i< tmp_b.getSize(); i++){
        tmp_b.setValue(i,b.getValue(p[i]));
    }

    return tmp_b;
}

BitArray inv_ip(BitArray b){
    BitArray tmp_b(8);
    int p[] = {3,0,2,4,6,1,7,5};
    int i;

    for(i = 0; i< tmp_b.getSize(); i++){
        tmp_b.setValue(i,b.getValue(p[i]));
    }

    return tmp_b;
}

BitArray _xor(BitArray a, BitArray b){
    BitArray tmp_b(a.getSize());
    int i;
    for(i = 0; i<a.getSize(); i++){
        if((a.getValue(i) && !b.getValue(i)) ||
           (!a.getValue(i) && b.getValue(i))){
            tmp_b.setValue(i,true);
        }
        else tmp_b.setValue(i,false);
    }

    return tmp_b;
}

BitArray sX(int m, BitArray b){
    std::string t_sX[4][4];
    if(m == 0){
        t_sX[0][0] = "01";t_sX[0][1] = "00";t_sX[0][2] = "11";t_sX[0][3] = "10";
        t_sX[1][0] = "11";t_sX[1][1] = "10";t_sX[1][2] = "01";t_sX[1][3] = "00";
        t_sX[2][0] = "00";t_sX[2][1] = "10";t_sX[2][2] = "01";t_sX[2][3] = "11";
        t_sX[3][0] = "11";t_sX[3][1] = "01";t_sX[3][2] = "11";t_sX[3][3] = "10";
    }
    else if(m == 1){
        t_sX[0][0] = "00";t_sX[0][1] = "01";t_sX[0][2] = "10";t_sX[0][3] = "11";
        t_sX[1][0] = "10";t_sX[1][1] = "00";t_sX[1][2] = "01";t_sX[1][3] = "11";
        t_sX[2][0] = "11";t_sX[2][1] = "00";t_sX[2][2] = "01";t_sX[2][3] = "00";
        t_sX[3][0] = "10";t_sX[3][1] = "01";t_sX[3][2] = "00";t_sX[3][3] = "11";
    }
    int row = 0, col = 0;
    if(b.getValue(0)) row = 2;
    if(b.getValue(3)) row++;
    if(b.getValue(1)) col = 2;
    if(b.getValue(2)) col++;

    BitArray tmp_b(2);
    tmp_b.fromString(t_sX[row][col]);
    return tmp_b;
}

BitArray f(BitArray R, BitArray key){
    BitArray tmp_b(8), spl_l, spl_r;
    tmp_b = _xor(exp_permute(R),key);
    tmp_b.split(spl_l,spl_r);

    return permute4(sX(0,spl_l),sX(1,spl_r));
}

BitArray fk(BitArray L, BitArray R,BitArray key){
    return _xor(f(R,key),L);
}

BitArray _crypt(int method, BitArray p_text, BitArray key){
    BitArray tmp2(8), k1(8), k2(8);
    BitArray tmp(10);
    BitArray spl_l, spl_r, L, R;
    BitArray R2(4);

    tmp = permute10(key);
    tmp.split(spl_l,spl_r);

    spl_l.lShift(1);
    spl_r.lShift(1);

    tmp.fromString(spl_l.toString()+spl_r.toString());
    k1 = permute8(tmp);

    spl_l.lShift(2);
    spl_r.lShift(2);

    tmp.fromString(spl_l.toString()+spl_r.toString());

    k2 = permute8(tmp);

    if(method == M_DECRYPT){
        tmp2.fromString(k1.toString());
        k1.fromString(k2.toString());
        k2.fromString(tmp2.toString());
    }
    if(method == M_ENCRYPT);

    p_text = ip(p_text);
    p_text.split(L,R);

    R2 = fk(L,R,k1);
    tmp2.fromString(fk(R,R2,k2).toString()+R2.toString());

    return inv_ip(tmp2);
}
